document.getElementById('files').addEventListener('change', handleFileSelect, false);

(function(a,b){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4)))window.alert(b)})(navigator.userAgent||navigator.vendor||window.opera,'Mobile is unsupported for now. Contact me if you know a cropping library that supports handheld devices.');

var sourceX;
var sourceY;
var sourceWidth;
var sourceHeight;
var coordw;
var coordh;
var stage;
var layer;

function handleFileSelect(evt) {
    var files = evt.target.files; // FileList object

    // Loop through the FileList and render image files as thumbnails.
    for (var i = 0, f; f = files[i]; i++) {

      // Only process image files.
      if (!f.type.match('image.*')) {
        continue;
      }

      var reader = new FileReader();

      // Closure to capture the file information.
      reader.onload = (function(theFile) {
        return function(e) {
          // Render thumbnail.
          var span = document.createElement('span');
          span.innerHTML = ['<img class="thumb" id="yourimage" src="', e.target.result,
                            '" title="', escape(theFile.name), '"/>'].join('');
          document.getElementById('uploadedimage').insertBefore(span, null);
					$('#yourimage').Jcrop({
						onChange: sendCoordinates,
						onSelect: sendCoordinates,
						aspectRatio: 1
					});	
        };
      })(f);

      // Read in the image file as a data URL.
      reader.readAsDataURL(f);
    }
  }

function sendCoordinates(coords) {
	coordw = coords.w;
	coordh = coords.h;
	// draw cropped image
	sourceX = coords.x;
	sourceY = coords.y;
	sourceWidth = coords.w/4;
	sourceHeight = coords.h/4;
};

function sliceAndDice() {
	if (stage == null) {
		stage = new Kinetic.Stage({
			container: "rearrange",
			width: 600,
			height: 600
		});

		layer = new Kinetic.Layer();
	};
	
	var imageObj = new Image();
	imageObj.src = document.getElementById('yourimage').src;
	var context11image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 0,
		y: 100+ 0,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX,
			y: sourceY,
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context12image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 100,
		y: 100+ 0,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4),
			y: sourceY,
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context13image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 200,
		y: 100+ 0,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4*2),
			y: sourceY,
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context14image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 300,
		y: 100+ 0,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4*3),
			y: sourceY,
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context21image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 0,
		y: 100+ 100,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX,
			y: sourceY+(coordh/4),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context22image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 100,
		y: 100+ 100,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4),
			y: sourceY+(coordh/4),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context23image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 200,
		y: 100+ 100,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4*2),
			y: sourceY+(coordh/4),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context24image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 300,
		y: 100+ 100,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4*3),
			y: sourceY+(coordh/4),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context31image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 0,
		y: 100+ 200,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX,
			y: sourceY+(coordh/4*2),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context32image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 100,
		y: 100+ 200,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4),
			y: sourceY+(coordh/4*2),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context33image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 200,
		y: 100+ 200,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4*2),
			y: sourceY+(coordh/4*2),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context34image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 300,
		y: 100+ 200,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4*3),
			y: sourceY+(coordh/4*2),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context41image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 0,
		y: 100+ 300,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX,
			y: sourceY+(coordh/4*3),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context42image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 100,
		y: 100+ 300,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4),
			y: sourceY+(coordh/4*3),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context43image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 200,
		y: 100+ 300,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4*2),
			y: sourceY+(coordh/4*3),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	var context44image = new Kinetic.Image({
		image: imageObj,
		x: 100+ 300,
		y: 100+ 300,
		draggable: true,
		width: 100,
		height: 100,
		crop: {
			x: sourceX+(coordw/4*3),
			y: sourceY+(coordh/4*3),
			width: sourceWidth,
			height: sourceHeight
		}
	});
	
	context11image.on('mouseover', function() {
    document.body.style.cursor = 'pointer';
  });
  context11image.on('mouseout', function() {
   document.body.style.cursor = 'default';
  });
	
	layer.add(context11image);
	layer.add(context12image);
	layer.add(context13image);
	layer.add(context14image);
	layer.add(context21image);
	layer.add(context22image);
	layer.add(context23image);
	layer.add(context24image);
	layer.add(context31image);
	layer.add(context32image);
	layer.add(context33image);
	layer.add(context34image);
	layer.add(context41image);
	layer.add(context42image);
	layer.add(context43image);
	layer.add(context44image);
	stage.add(layer);
}